package no.rwr.awt;

import java.awt.EventQueue;
import java.awt.AWTEvent;

public class EventPump implements Runnable {
    
    EventQueue queue;
    Thread eventThread;
    
    public EventPump(EventQueue queue) {
	this.queue = queue;

	eventThread = new Thread(this, "Event thread");
	eventThread.start();
    }

    public void run() {
	while (true) {
	    dispatchNextEvent();
	}
    }
    
    void dispatchNextEvent() {
	try {
	    AWTEvent event = queue.getNextEvent();
	    EventQueueAccess.dispatchEvent(queue, event);
	} catch (InterruptedException ie) {
	    throw new RuntimeException(ie.toString());
	}
    }
}

class EventQueueAccess extends EventQueue {
    public static void dispatchEvent(EventQueue queue, AWTEvent event) {
	queue.dispatchEvent(event);
    }
}
