package no.rwr.x;
import gnu.gcj.RawData;
import java.awt.Rectangle;



/**
   There is no need to do coalescing of changes since Xlib will do
   this for us.
 */
public class GC implements Cloneable {
    
    public GC(Drawable targetType) {
	this.targetType = targetType;
    }

    public GC create() {
	GC clone;
	try {
	    clone = (GC) clone();

	} catch (CloneNotSupportedException cnse) {
	    throw new Error("should never happen:" + cnse.toString());
	}
	copyStructures(clone);
	clone.clipUpToDate = (clip == null);
	return clone;
    }

    native RawData getValues();
    native RawData getStructure();
    public native void copyStructures(GC target);

    public native void dispose();

    public void finalize() {
	dispose();
    }

    public native void setForeground(long pixel);
    public native void setFont(no.rwr.x.Font font);

    public void setClipRectangles(Rectangle[] rectangles) {
	clip = new Clip(rectangles);
	clipUpToDate = false;
    }


    public native void drawString(String text, int x, int y);
    public native void drawLine(int x1, int y1, int x2, int y2);
    public native void drawRectangle(int x, int y, int w, int h);


    public native void fillRectangle(int x, int y, int w, int h);
    public native void clearArea(int x, int y, int w, int h,
				 boolean exposures);



    public native void putImage(XImage image,
				int srcX, int srcY,
				int destX, int destY,
				int width, int height);

    private Drawable targetType;
    private RawData structure;
    

    private long valueMask;
    private long setMask;
    private RawData values;

    private Clip clip;
    private boolean clipUpToDate = true;
}

