package no.rwr.x;


/** Interprets an XButtonEvent into members of java primitive types. */
public class XButtonEvent extends XEvent {

    public static final int MASK_SHIFT   = 1<<0;
    public static final int MASK_LOCK    = 1<<0;
    public static final int MASK_CONTROL = 1<<0;
    public static final int MASK_MOD1    = 1<<0;
    public static final int MASK_MOD2    = 1<<0;
    public static final int MASK_MOD3    = 1<<0;
    public static final int MASK_MOD4    = 1<<0;
    public static final int MASK_MOD5    = 1<<0;
    

    public XButtonEvent(XAnyEvent event) {
	super(event);
	// FIXME: Avoid double checking?

	if ((event.getType() != XAnyEvent.TYPE_BUTTON_PRESS) &&
	    (event.getType() != XAnyEvent.TYPE_BUTTON_RELEASE)) {
	    throw new IllegalArgumentException("Wrong event type");
	}
	init();
    }

    native void init();

    public long time;
    public int  x;
    public int  y;
    public int  state;
    public int  button;
}



