#include <X11/Xlib.h>

#include <gcj/cni.h>
#include <gnu/gcj/RawData.h>

#include <java/lang/RuntimeException.h>

#include <java/lang/System.h>
#include <java/io/PrintStream.h>

#include "no/rwr/x/Display.h"
#include "no/rwr/x/Window.h"
#include "no/rwr/x/XAnyEvent.h"
#include "no/rwr/x/XExposeEvent.h"
#include "no/rwr/x/XException.h"

#include <iostream>


void no::rwr::x::XAnyEvent::init() {
    ::XEvent* event = new ::XEvent;
    structure = reinterpret_cast<gnu::gcj::RawData*>(event);
}

void no::rwr::x::XAnyEvent::finalize() {
    delete structure;
    structure = 0;
}

void no::rwr::x::XAnyEvent::loadNext() {
    ::Display* dpy = (::Display*) display->display;
    ::XEvent* evt = (::XEvent*) structure;
    XNextEvent(dpy, evt);
    // What does XNextEvent return?
}

jint no::rwr::x::XAnyEvent::getType() {
    ::XEvent* event = (::XEvent*) structure;
    return event->type;
}

void no::rwr::x::XAnyEvent::setType(jint type) {
    ::XEvent* event = (::XEvent*) structure;
    event->type = type;
}

no::rwr::x::Window* no::rwr::x::XAnyEvent::getWindow() {
    ::XEvent* event = (::XEvent*) structure;
    return display->getWindow(event->xany.window);
}

void no::rwr::x::XAnyEvent::setWindow(no::rwr::x::Window* window) {
    ::XEvent* event = (::XEvent*) structure;
    event->xany.window = window->getXID();
}

jlong no::rwr::x::XAnyEvent::getSerial() {
    ::XEvent* event = (::XEvent*) structure;
    return event->xany.serial;
}

void no::rwr::x::XAnyEvent::send(no::rwr::x::Window* destination,
			      jboolean propagate, jlong mask) {
    ::Display* dpy = (::Display*) display->display;
    ::XEvent* event = (::XEvent*) structure;

    Status status = 
	XSendEvent(dpy, destination->getXID(), propagate ? True : False,
		   mask, event);

    switch (status) {
    case 0:
	JvThrow(new XException(JvNewStringLatin1("conversion to wire "
						 "protocol failed")));
    case BadWindow:
    case BadValue:
	JvThrow(new XException(display, status));
    default:
	/* All other return values indicate success.  Ie. (status ==
	   1) indicates success, not BadRequest. */
	; // NOP
    }

}
